<script lang="ts">
	import { fade } from 'svelte/transition';
	import { clickOutside } from '$lib/clickOutside';
	import Input from '../../../../components/Main/Input.svelte';
	import Button from '../../../../components/Main/Button.svelte';

	import { onMount } from 'svelte';
	import { format } from 'date-fns';
	import { makeReservation } from '../../../api/reservation/reservation';
	import type { ReservationInput } from '../../../api/reservation/types';
	import { addItemToCart } from '$lib/reservation';
	import toast from 'svelte-french-toast';
	import { refreshCart } from '../../../../stores/reservation';

	export let showModal = false;
	export let id: number;

	let arrivalDate = format(new Date(), 'yyyy-MM-dd');
	let numberOfDays = '';

	let customerID = '';
	onMount(() => {
		customerID = sessionStorage.getItem('customerID') || '';
		console.log(customerID);
	});

	function closeModal() {
		showModal = false;
	}

	function handleReservation() {
		// Ajoute ici la logique pour gérer la réservation (par exemple, envoyer les données au serveur)
		const requestReservation: ReservationInput = {
			customerID: { value: customerID },
			checkInDate: new Date(arrivalDate).toISOString(),
			numberOfNights: parseInt(numberOfDays),
			roomType: id
		};
		addItemToCart(requestReservation);
		setTimeout(() => {
			toast.success('Chambre ajoutée au panier');
			$refreshCart = true;
			showModal = false;
		}, 1000);
	}

	// $: console.log(arrivalDate, arrivalDate ? new Date(arrivalDate).toISOString() : '');
</script>

{#if showModal}
	<div
		class="modal fixed inset-0 flex items-center justify-center bg-dark-surface-500 bg-opacity-40"
		transition:fade
	>
		<div
			class="modal-content bg-light-surface-500 p-8 rounded-lg shadow-lg w-80 flex flex-col gap-4"
			use:clickOutside
			on:click_outside={closeModal}
		>
			<h2 class="text-2xl font-bold mb-4">Réservation</h2>

			<Input label="Date d'arrivée" bind:value={arrivalDate} type="date" />
			<Input label="Nombre de jours" bind:value={numberOfDays} type="number" />

			<Button on:click={handleReservation} disabled={!customerID}>Confirmer la réservation</Button>
		</div>
	</div>
{/if}
